function [loglik, s_up, error, sol, sysm,others] = evalmod_kalman_gensys(param, YY, estinfo, modelname)

% housekeeping
nobs = size(YY,1);
error = 0;
sol = [];

% sysmat for kalman
order_app = 1;

% evaluate sysmat
eval(['[DD,ZZ,HH,TT,RR,QQ,gensol] = ', ...
    modelname, 'sysmat(param, order_app, estinfo, modelname);']);
verysmall = estinfo.zerocleaning;
% CC1(abs(CC1)<verysmall) =0;
% CC2(abs(CC2)<verysmall) =0;
TT(abs(TT)<verysmall)   =0;
RR(abs(RR)<verysmall)   =0;
% /**********************************************************
% ** Check determinacy 
% eu(1)=1 for existence, eu(2)=1 for uniqueness.  eu(1)=-1 for
% existence only with not-s.c. z; eu=[-2,-2] for coincident zeros.
% **********************************************************/
if (gensol.RC(1) == 1) && (gensol.RC(2)==1);
   %/* determinacy */
   error = 0;
elseif (gensol.RC(1) == 1) && (gensol.RC(2)==0);
   %/* indeterminacy */
   error = 1;
else
   %/* no equilibrium exists, numerical problems */
   error = 2;
end

% Sungbae An's KF
sysm.DD = DD;
sysm.ZZ = ZZ;
sysm.HH = sqrt(HH); %standard dev

sysm.CC = zeros(size(TT,1),1);
sysm.TT = TT;
sysm.RR = RR*sqrt(QQ); 
sysm.QQ = eye(size(QQ,1)); %no QQ



% initial mean and variance for state vector
if error == 0
    [s00, P00, sysm.tg0] = initialize_kf(size(sysm.TT,1),sysm.TT,RR,QQ,modelname,gensol);
    if estinfo.infle == 0
        [loglikiii,filtmv,loglik]=kalmanf(sysm,s00,P00,YY);
    else
        %sysm.tg0 = gensol.tg0;
        [loglikiii,filtmv,loglik]=kalmanf_infle(sysm,s00,P00,YY);
    end
    s_up = filtmv.s0;
    
    others.filtmv = filtmv;
    others.fcsterr = filtmv.fcsterr;
    others.fcst = filtmv.fcst;

    % to generate prediction
    if estinfo.predXlast == 1
        sysm.Xlastfix  = filtmv.s0(:,end);
        sysm.Xlastdraw = filtmv.s0(:,end) + sqrtSVD(filtmv.PT)*randn(size(sysm.TT,1),1);
        sysm.XlastPT   = filtmv.PT;
    end
end

% save solution end
% ---------------------
% error from sysmat
if error ~= 0
    loglik =  -inf;
    s_up = [];
    sysm = [];
    return;    
end

% error control
if any(~isreal(loglik))
    error = 20;
    loglik = -inf;
    s_up = [];
    sysm = [];
end






























