function [x0, P0, tg0] = initialize_kf(nx,Phi,R,S2,modelname,gensol)

tg0 = [];

if nargin < 5
    % initialization of KF
    x0 = zeros(nx,1);
    P0 = dlyap(Phi,R*S2*R');
else
    if strcmp(modelname, 'NKASGAPlogkapGENSYS_')||strcmp(modelname, 'NKASGRlogkapGENSYS_')||strcmp(modelname, 'NK2HAGR_')...
            ||strcmp(modelname, 'oldpaper2012_') ...
            ||strcmp(modelname, 'HB2012_')||strcmp(modelname, 'HB2012_sbsv_') ...
            ||strcmp(modelname, 'HB2012ST_')||strcmp(modelname, 'HB2012ST_sbsv_') ...
            ||strcmp(modelname, 'HB2012_trgtar_')||strcmp(modelname, 'HB2012_trgtar_sbsv_')...
            ||strcmp(modelname, 'HB2012ST_trgtar_') ||strcmp(modelname, 'HB2012ST_trgtar_sbsv_')
        % initialization of KF
        x0 = zeros(nx,1);
        P0 = dlyap(Phi,R*S2*R');
        
    elseif strcmp(modelname, 'HB2012_trgt_')||strcmp(modelname, 'HB2012_trgt_sbsv_')|| ...
           strcmp(modelname, 'HB2012ST_trgt_')||strcmp(modelname, 'HB2012ST_trgt_sbsv_')
        % initialization of KF
        x0 = zeros(nx,1);
        x0(end,:) = gensol.tg0; % we estimate initial target rate
          
        Phi(end,:) = [];
        Phi(:,end) = [];
        R(end,:) = [];
        R(:,4) = [];
        S2(:,4) = [];
        S2(4,:) = [];
        
        temp_P0 = dlyap(Phi,R*S2*R');
        P0 = zeros(nx);
        P0(1:end-1,1:end-1) = temp_P0;
        P0(end,end) = 0;

%     elseif strcmp(modelname, 'HB2012ST_trgt_')
%         % initialization of KF
%         x0 = zeros(nx,1);
%         x0(8,:)  = gensol.zz0;
%         x0(12,:) = gensol.tg0; % we estimate initial target rate
% 
%         URindx = [8, 12]; %UR states (z_t and TG_t)
%         nURindx = setdiff((1:1:12)', URindx);
%         Phi(URindx,:) = [];
%         Phi(:,URindx) = [];
%         R(URindx,:)   = [];
%         
%         R(:,3:4) = []; %both ez and eTG
%         S2(:,3:4) = []; %both ez and eTG
%         S2(3:4,:) = []; %both ez and eTG
%         
%         temp_P0 = dlyap(Phi,R*S2*R');
%         
%         P0 = zeros(nx);
% 
%         P0(nURindx,nURindx) = temp_P0;
%         
%         P0(URindx,URindx) = 0;
        
        
    elseif strcmp(modelname, 'NKASGAPITlogkapGENSYS_')||strcmp(modelname, 'NKASGAPIT2logkapGENSYS_') ...% we need to take account for Unit-root target rate
            ||strcmp(modelname, 'NKASGRITlogkapGENSYS_')||strcmp(modelname, 'NKASGRIT2logkapGENSYS_')
        % initialization of KF
        x0 = zeros(nx,1);
        x0(end-1,:) = gensol.tg0; %we estimate initial target rate
        tg0 = gensol.tg0;
        
        %P0 = zeros(nx,nx);
        
        Phi(end-1,:) = [];
        Phi(:,end-1) = [];
        R(end-1,:) = [];
        R(:,4) = [];
        S2(:,4) = [];
        S2(4,:) = [];
        
        temp_P0 = dlyap(Phi,R*S2*R');
        
        P0 = zeros(nx);
        lH = ones(nx);
        lH(end-1,:) = 0;
        lH(:,end-1) = 0;
        P0(logical(lH)) = temp_P0;
        P0(nx-1,nx-1) = 0;

    else
        x0 =[]; P0 = [];
        disp('initialize_kf: no modelname');
    end
end