function param = pmsv(modelname, paraname)

if strcmp(modelname, 'HB2012_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750;
    zeta_p       = 0.1130;
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9;
    varphi_z     = 0.1;
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
    pistgap = 5;
    p1 = 0.97;
    p2 = 0.90;
    
    gamgap = 0.3; %for ms11, gamst gap
    
elseif strcmp(modelname, 'HB2012_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750;
    zeta_p       = 0.1130;
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9;
    varphi_z     = 0.1;
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
%     pistgap = 5;
%     p1 = 0.97;
%     p2 = 0.90;
%     
%     gamgap = 0.3; %for ms11, gamst gap

elseif strcmp(modelname, 'HB2012ST_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750;
    zeta_p       = 0.1130;
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9;
    varphi_z     = 0.1;
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
    pistgap = 5;
    p1 = 0.97;
    p2 = 0.90;
    
    gamgap = 0.3; %for ms11, gamst gap
    
elseif strcmp(modelname, 'HB2012ST_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750;
    zeta_p       = 0.1130;
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9;
    varphi_z     = 0.1;
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
%     pistgap = 5;
%     p1 = 0.97;
%     p2 = 0.90;
%     
%     gamgap = 0.3; %for ms11, gamst gap


elseif strcmp(modelname, 'HB2012_trgt_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;

elseif strcmp(modelname, 'HB2012_trgtar_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    rhoTG = 0.98;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
elseif strcmp(modelname, 'HB2012_trgt_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;

elseif strcmp(modelname, 'HB2012_trgtar_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    rhoTG = 0.98;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
elseif strcmp(modelname, 'HB2012ST_trgt_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;

elseif strcmp(modelname, 'HB2012ST_trgtar_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    rhoTG = 0.98;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
elseif strcmp(modelname, 'HB2012ST_trgt_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;

elseif strcmp(modelname, 'HB2012ST_trgtar_sbsv_')
    
    sig_C        =  1.8660;
    nu_l         = 1.8150;
    iota_p       = 0.4750; %0.4750
    zeta_p       = 0.113; %0.113
    psi1         = 2;
    psi2         = 0.2420;
    rhor        = 0.3690;
    rrst    = 0.3750;
    pist    = 2.2260;
    gamst   = 0.3900;
    rhog        = 0.9;
    rhoz        = 0.9; %0.9
    varphi_z     = 0.1; %0.1
    sigr        = 0.5290;
    sigg        = 1.4740;
    sigz        = 0.6880;
    
    sigr0        = 1; %before break
    sigg0        = 0.5;
    sigz0        = 0.2;
    
    sigtg  = 0.1;
    tg0    = 0.5;
    sigmtg = 0.1;
    rhoTG = 0.98;
    
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
% elseif strcmp(modelname, 'HB2012_sbsv_trgt_')
%     
%     sig_C        =  1.8660;
%     nu_l         = 1.8150;
%     iota_p       = 0.4750;
%     zeta_p       = 0.1130;
%     psi1         = 2;
%     psi2         = 0.2420;
%     rhor        = 0.3690;
%     rrst    = 0.3750;
%     pist    = 2.2260;
%     gamst   = 0.3900;
%     rhog        = 0.9;
%     rhoz        = 0.9;
%     varphi_z     = 0.1;
%     sigr        = 0.5290;
%     sigg        = 1.4740;
%     sigz        = 0.6880;
%     
%     sigr0        = 1; %before break
%     sigg0        = 0.5;
%     sigz0        = 0.2;
%     
%     sigtg  = 0.1; 
% %     sigtg0  = 0.3; %before break
%     tg0    = 0.5;
%     sigmtg = 0.1;
%     
%     sigmy = 0.2300   ;
%     sigmp = 0.5600    ;
%     sigmr = 0.6600   ;
%     
% %     pistgap = 5;
% %     p1 = 0.97;
% %     p2 = 0.90;
% %     
% %     gamgap = 0.3; %for ms11, gamst gap

elseif strcmp(modelname, 'oldpaper2012_')
    tau   = 0.3     ;
    nu    = .1     ;
    kap   = 0.2;
    cyst  = .85    ;
    psi1  = 1.7    ;
%     psi1  = 1.5    ;
    psi2  = 0.5  ;
    rhor  = .7    ;
    rhog  = 0.9   ;
    rhoz  = 0.9    ;
%     rhoz  = 0.5    ;
    rrst  =0.8    ;
    %pist  = 5    ;
    pist  = 2    ;
    gamst = 0.55   ;
    sigr  = 0.0025  ;
    sigg  = 0.01  ;
    sigz  = 0.002  ;
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
    pistgap = 7;
    p1 = 0.97;
    p2 = 0.95;
    
    gamgap = 0.3; %for ms11, gamst gap
    
elseif strcmp(modelname, 'NK2HAGR_')
    
    % parameter values
    h    = 0.9;
    nu_l = 1;
    lam  = 0.5;
    zet = 0.8;
    iota = 0.2;
    
    psi1  = 1.5000    ; % psi1  = 1.5000
    psi2  = 0.80    ; % psi2  = 0.1250
    rhor  = 0.900   ;
    rhog  = 0.900   ;
    rhoz  = 0.500    ;
    rrst  = 0.6    ;
    pist  = 3    ;
    gamst = 0.5500   ;
    pistst = 1;
    sigr  = 0.50  ;
    sigg  = 0.50  ;
    sigz  = 0.50  ;
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    
    pistgap = 7;
    p1 = 0.97;
    p2 = 0.95;
    
    gamgap = 0.3; %for ms11, gamst gap
    
    
elseif strcmp(modelname, 'NKASGAPlogkapGENSYS_')||strcmp(modelname, 'NKASGRlogkapGENSYS_')
    
    % parameter values
    tau   = 3.0    ;
    nu    = 0.1000    ;
    kap   = 0.1   ;
    cyst  = 0.8500    ;
    psi1  = 1.8000    ; % psi1  = 1.5000
    psi2  = 0.80    ; % psi2  = 0.1250
    rhor  = 0.900   ;
    rhog  = 0.900   ;
    rhoz  = 0.500    ;
    rrst  = 0.5000    ;
    pist  = 2.5000    ;
    gamst = 0.5500   ;
    sigr  = 0.050  ;
    sigg  = 0.050  ;
    sigz  = 0.050  ;
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    pistgap = 7;
    p1 = 0.97;
    p2 = 0.95;
    
    gamgap = 0.3; %for ms11, gamst gap
    
elseif strcmp(modelname, 'NKASGAPITlogkapGENSYS_')||strcmp(modelname, 'NKASGRITlogkapGENSYS_')
    
    % parameter values
    tau   = 4    ;
    nu    = 0.1000    ;
    kap   = 0.1   ;
    cyst  = 0.8500    ;
    psi1  = 1.8000    ; % psi1  = 1.5000
    psi2  = 0.12    ; % psi2  = 0.1250
    rhor  = 0.900   ;
    rhog  = 0.900   ;
    rhoz  = 0.900    ;
    rrst  = 0.5000    ;
    pist  = 2.5000    ;
    gamst = 0.5500   ;
    sigr  = 0.25  ;
    sigg  = 0.20  ;
    sigz  = 0.30  ;
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    sigtg = 0.5;
    tg0   = 0.01;
elseif strcmp(modelname, 'NKASGAPIT2logkapGENSYS_')||strcmp(modelname, 'NKASGRIT2logkapGENSYS_')
        % parameter values
    tau   = 4    ;
    nu    = 0.1000    ;
    kap   = 0.1   ;
    cyst  = 0.8500    ;
    psi1  = 1.8000    ; % psi1  = 1.5000
    psi2  = 0.12    ; % psi2  = 0.1250
    rhor  = 0.900   ;
    rhog  = 0.900   ;
    rhoz  = 0.900    ;
    rrst  = 0.5000    ;
    pist  = 2.5000    ;
    gamst = 0.5500   ;
    sigr  = 0.25  ;
    sigg  = 0.20  ;
    sigz  = 0.30  ;
    sigmy = 0.2300   ;
    sigmp = 0.5600    ;
    sigmr = 0.6600   ;
    sigtg = 0.5;
    tg0   = 0.01;
    sigme = 0.2;
else
    disp('pmsv: no modelname');
    pause
end

% assign values
npara = size(paraname,1);
param = nan*ones(npara,1);
for i=1:1:npara;
    eval(['param(', num2str(i),',1) = ', paraname{i}, ';']);
end