function YYsim = dsgepredmult_new_ms01(sol, Xhatlast, horizon, ntraj, order_app)

% for ms01

% procedure to compute multiple predictions
% Remark
%  - I used chol insead of cholpsd

% recover solution
DD = sol.DD;
ZZ = sol.ZZ;
HH = sol.HH;
CC1 = sol.CC1;
CC2 = sol.CC2;
TT = sol.TT;
RR = sol.RR;
QQ = sol.QQ;
RRsqrtQQ = RR*chol(QQ)'; %QQ is eye

strans = sol.strans;

% size of matrices
ne        = size(RR,2);
[ny, nx]  = size(ZZ);
nm        = size(HH,1); %# of measured variable
nvar      = nm;

% simulate path
Mt    = sol.mtlast;
Xt    = Xhatlast'; %states
YYsim = zeros(ntraj, nvar*horizon); %prediction

for trajind = 1:1:ntraj
    
    YYfcst = zeros(horizon, nvar);
    Xtfcst = Xt;
    Mtfcst = Mt;
    
    for t = 1:1:horizon
        
        % MS transition
        probs = strans*Mtfcst';
        draws = rand < probs(1);
        Mtfcst = [draws, (1-draws)];
        if Mtfcst(1) == 1
            CC = CC1;
        else
            CC = CC2;
        end
        
        % States
        Xtfcst = CC + TT*Xtfcst + RRsqrtQQ*randn(ne,1); 
        
        % Measurement
        YYfcst(t,:) = (DD + ZZ*Xtfcst + HH*randn(nm,1))';
        
    end
    
    YYsim(trajind,:) = reshape(YYfcst,[],1)';
    
end


% 
% if order_app == 1
% %     if n_particle == 0
% %         
% %         % kalman filter
% %         bigzeros = zeros(ny+nx,ny);
% %         Phi = [PP1G*PP1H; PP1H];
% %         Phi = [bigzeros Phi];
% %         R   = [PP1G*sigeta; sigeta];
% %         S2  = eye(ne);
% %         H   = HH;
% %         A   = DD;
% %         B   = ZZ;
% %         
% %         % State estimates
% %         At = [Yhatlast Xhatlast]';
% %         
% %         % Given At, simulate yt + horizon
% %         YYsim = zeros(ntraj, nvar*horizon);
% %         
% %         Hpsd = H; % H is already sqrt matrix
% %         for trajind=1:1:ntraj
% %             
% %             YYfcst = zeros(horizon, nvar);
% %             Atfcst = At;
% %             
% %             for t = 1:1:horizon
% %                 Atfcst = Phi*Atfcst + R*randn(ne,1);
% %                 YYfcst(t,:) = (B*Atfcst + A + Hpsd*randn(nm,1))';
% %             end
% %             
% %             YYsim(trajind,:) = reshape(YYfcst,[],1)';
% %             
% %         end
% %         
% %     else
%         
%         % particle filter
%         Xt = Xhatlast';
%         YYsim = zeros(ntraj, nvar*horizon);
%         
%         for trajind = 1:1:ntraj
%             
%             YYfcst = zeros(horizon, nvar);
%             Xtfcst = Xt;
%             
%             for t = 1:1:horizon
%                 
%                 % Predetermined
%                 Xtfcst = PP1H*Xtfcst + sigeta*randn(ne,1);
%                 
%                 % Controls
%                 temp_Ytfcst = PP1G*Xtfcst;
%                 
%                 % Measurement
%                 YYfcst(t,:) = (DD + ZZ*[temp_Ytfcst; Xtfcst] + HH*randn(nm,1))';
%                 
%             end
%             
%             YYsim(trajind,:) = reshape(YYfcst,[],1)';
%             
%         end
%         
% %     end
%     
% elseif order_app == 2
%     
%     % particle filter
%     Xt = Xhatlast';
%     YYsim = zeros(ntraj, nvar*horizon);
%     
%     for trajind = 1:1:ntraj
%         
%         YYfcst = zeros(horizon, nvar);
%         Xtfcst = Xt;
%             AA = kron(Xtfcst, Xtfcst);
%         
%         for t = 1:1:horizon
%             
%             % Predetermined
%             Xtfcst = PP0H + PP1H*Xtfcst + PP2H*AA + sigeta*randn(ne,1);
%             
%             % Controls
%             AA = kron(Xtfcst, Xtfcst);
%             temp_Ytfcst = PP0G + PP1G*Xtfcst + PP2G*AA;
%             
%             % Measurement
%             YYfcst(t,:) = (DD + ZZ*[temp_Ytfcst; Xtfcst] + HH*randn(nm,1))';
%             
%         end
%         
%         YYsim(trajind,:) = reshape(YYfcst,[],1)';
%         
%     end
%     
% elseif order_app == 3
%     
%     % particle filter
%     Xt = Xhatlast';
%     YYsim = zeros(ntraj, nvar*horizon);
%     
%     for trajind = 1:1:ntraj
%         
%         YYfcst = zeros(horizon, nvar);
%         Xtfcst = Xt;
%             AA = kron(Xtfcst, Xtfcst);
%         
%         for t = 1:1:horizon
%             
%             % Predetermined
%             Xtfcst = PP0H + PP1H*Xtfcst + PP2H*AA + PP3H*kron(Xtfcst,AA) + sigeta*randn(ne,1);
%             
%             % Controls
%             AA = kron(Xtfcst, Xtfcst);
%             temp_Ytfcst = PP0G + PP1G*Xtfcst + PP2G*AA + PP3G*kron(Xtfcst, AA);
%             
%             % Measurement
%             YYfcst(t,:) = (DD + ZZ*[temp_Ytfcst; Xtfcst] + HH*randn(nm,1))';
%             
%         end
%         
%         YYsim(trajind,:) = reshape(YYfcst,[],1)';
%         
%     end
% else
%     disp('dsge_pred: order_app should be smaller than 3');
% end
