function [Hlast, Rlast, Vlast, Clast, sigt, smooth_n, smooth_e,h_aT, h_PT] = objfcn_gibbs_sv_Qone(sol, sigt, YY, Hlast, Rlast, Vlast, Clast, priorSV, estinfo)
% function to draw gibbs part of DSGE-SVlinear model
% 2015/03/13

% % recover system matrices
% [ny, nx] = size(sol.PP1G);
% ZZ1 = sol.ZZ(:,1:ny);
% ZZ2 = sol.ZZ(:,ny+1:end);
% A   = sol.DD + ZZ1*sol.PP0G;
% B   = ZZ1*sol.PP1G+ZZ2;
% H   = (sol.HH).^2; % HH is sqrt matrix
% Phi = sol.PP1H;
% R   = sol.sigeta;



% [1] Disturbance simulation smoother
% - note that sol.HH is sqrt(H)
% [smooth_n, smooth_e] = simul_disturbance_sv(YY, sol.TT, sol.RR, sol.DD, sol.ZZ, sol.HH.^2, sigt);

[x0, P0] = initialize_kf(size(sol.TT,1),sol.TT,sol.RR,sol.QQ,estinfo.modelname,sol); % assume SV is in ss (ht=0)
if estinfo.infle == 0
    [smooth_n, smooth_e] = simul_disturbance_ini_sv(YY, sol.TT, sol.RR, sol.DD, sol.ZZ, sol.HH.^2, sigt,x0,P0);
else
    mv_indx = logical(~(YY == -10));
    [smooth_n, smooth_e] = simul_disturbance_ini_sv_mv(YY, sol.TT, sol.RR, sol.DD, sol.ZZ, sol.HH.^2, sigt,x0,P0,mv_indx);
end
% [2] SV parameter sampler
% estinfo.SVloc = [1,2,3,4];
priorSV00.C1 = priorSV.C1(estinfo.SVloc);
priorSV00.C2 = priorSV.C2(estinfo.SVloc);

priorSV00.R1 = priorSV.R1(estinfo.SVloc);
priorSV00.R2 = priorSV.R2(estinfo.SVloc);
priorSV00.T  = priorSV.T(estinfo.SVloc);
priorSV00.V  = priorSV.V(estinfo.SVloc);
priorSV00.unitroot = priorSV.unitroot;

% [Hlast00,Rlast00,Vlast00,s,sigt00]=step_sv_setQone(smooth_n(:,estinfo.SVloc), Hlast(:,estinfo.SVloc),...
%                                    Rlast(estinfo.SVloc),Vlast(estinfo.SVloc),...
%                                    priorSV00);
[Hlast00,Rlast00,Vlast00,Clast00,s,sigt00,h_aT00,h_PT00]=step_sv_Qone(smooth_n(:,estinfo.SVloc), Hlast(:,estinfo.SVloc),...
                                   Rlast(estinfo.SVloc),Vlast(estinfo.SVloc),Clast(estinfo.SVloc),...
                                   priorSV00);
[nobs,ne] = size(smooth_n);

Hlast = zeros(nobs,ne);
Hlast(:,estinfo.SVloc) = Hlast00;
sigt = exp(Hlast);

Rlast = zeros(ne,1);
Rlast(estinfo.SVloc) = Rlast00;

Vlast = zeros(ne,1);
Vlast(estinfo.SVloc) = Vlast00;

Clast = zeros(ne,1);
Clast(estinfo.SVloc) = Clast00;

h_aT = zeros(ne,1);
h_aT(estinfo.SVloc) = h_aT00;
h_PT = zeros(ne,1);
h_PT(estinfo.SVloc) = h_PT00;







