function positive_post = objfcn_hess_adaptive_sbsv(para, prior, estinfo, YY, modelname, order_app, n_particle, T0_)
% objective function for dsge_hess.m
% - evaluates posterior density
% [1] Entered para is NOT transformed one
% [2] Control fixed parameters (pmask)
% updated: 2015/3/6 by minchul shin

% recover prior information
pshape   = prior(:,1);
pmean    = prior(:,2);
pstdd    = prior(:,3);
pmask    = prior(:,4);
pfix     = prior(:,5);
pmaskinv = 1 - pmask;
pshape   = pshape.*pmaskinv;

% modelpara = para;
% modelpara = modelpara.*pmaskinv + pfix.*pmask;

% construct full parameter vector by adding fixed parameter
nfix  = sum(pmask);
npara = nfix+size(para,1);
modelpara = zeros(npara,1);

modelpara(logical(pmaskinv),:) = para;
modelpara(logical(pmask),:) = pfix(logical(pmask),1);

% evaluation of likelihood
n_particle=0;
if order_app == 1 && n_particle == 0
    
    [loglik, s_up, error] = evalmod_kalman_gensys_sbsv(modelpara, [], YY, estinfo, modelname);
    %[loglik, s_up, error] = evalmod_kalman_gensys(modelpara, YY, estinfo, modelname);
    lnpY = sum(loglik(T0_:end,:));    
else
    disp('objfcn_hess: order&#particle are not defined');
end

% error control
if isempty(lnpY)||error~=0
    %positive_post = -inf;
    positive_post = -10000000000000;
    return
end

% evaluate the prior distribution
lnprio = priodens(modelpara, pmean, pstdd, pshape);
if ~isreal(lnprio);
    lnprio = -inf;
end

% posterior 
positive_post = lnpY + lnprio;






