function B = cholpsd(A)
% This procedure computes a Cholesky Decomposition for positive definite
% matrices

B = A;
n = size(B,1);
for k=1:1:n
    if B(k,k) > 0
        B(k,k) = sqrt(B(k,k));
        if k < n
            B(k+1:n, k) = B(k+1:n, k)/B(k,k);
            B(k, k+1:n) = zeros(1, n-k);
            for j=k+1:1:n
                B(j:n, j) = B(j:n, j) - B(j:n, k)*B(j,k);
            end
        end
    end
end
