function [C_bar, CC_bar, VC_inv] = refprior(lambda, YY, XX)
% Prior dist. for the reference model
% Intercept but no trend


% prior mean
nvar   = size(YY, 2);
nobs   = rows(YY, 1);
k      = size(XX, 1);

CC_bar = zeros(nvar, k);
C_bar  = reshape(CC_bar',[],1);

% prior variance
y = reshape(YY, [],1);
c_hat = kron(eye(nvar), (XX'*XX)^(-1)*XX')*y;
CC_hat = reshape(c_hat, nvar, k);
SIG_hat = diag(1/nobs *(YY'-CC_hat*XX')*(YY'-CC_hat*XX')');
SIG = (ones(nvar,1)./SIG_hat)*SIG_hat';

VC_inv = ones(nvar,1)*1e-3;

for i=1:1:(k-1)/nvar
    VC_inv = [VC_inv SIG.*(i/lambda)^2];
end

VC_inv = eye(nvar*k).*reshape(VC_inv', [], 1);

