function [prior, paraname, priorSV, priorMS, priorMS2] = prior_HB2012ST_trgtar_sbsv_d1p34o1pc0m1
% same as p1 but
% no measurement error
% /********************************************************************
% **
% **
% **   Notes:
% ** 
% **
% **   Each row has the following specification:
% **
% **      pdf,arg1,arg2,              mask,fix;
% **      pdf shape of prior density
% **                  1: BETA(mean,stdd)
% **                  2: GAMMA(mean,stdd)
% **                  3: NORMAL(mean,stdd)
% **                  4: INVGAMMA(s^2,nu)
% **                  5: UNIFORM(a,b)
% **                  0: no prior
% **      arg1    1st argument for pdf
% **      arg2    2nd argument for pdf
% **
% **      mask    1 if the parameter is fixed to constant
% **      fix     fixed parameter value (0 if mask=0)
% ********************************************************************/
% /* Recover pure parameters */
prior = [
 3, 1.5,0.37,  0,0;	  %sig_C     1
 2, 2.0, 0.75, 0,0;   %nu_l      2
 1, 0.5, 0.15, 0, 0;  %iota_p    3
 1, 0.5, 0.1, 0, 0;   %zeta_p    4
 3, 1.5, 0.25, 0, 0;  %psi1      5
 3, 0.12, 0.05, 0, 0; %psi2      6
 1, 0.5, 0.2, 0, 0;   %rhor     7
 2, 1, 0.4, 0, 0;     %rrst8
 2, 2.48, 0.4, 0, 2.48;  %pist9
 3, 0.4, 0.1, 0, 0;   %gamst10
 1, 0.5, 0.2, 0, 0;   %rhog  11   
 1, 0.5, 0.2, 1, 1;   %rhoz    12 
 5, -1.0, 1.0, 0, 0;  %varphi_z  13
 4, 0.1, 2, 0, 0;     %sigr     14
 4, 0.1, 2, 0, 0;     %sigg     15
 4, 0.1, 2, 0, 0;     %sigz   16
 
 4, 0.1, 2, 0, 0;     %sigr0     17
 4, 0.1, 2, 0, 0;     %sigg0     18
 4, 0.1, 2, 0, 0;     %sigz0   19
 
 4, 0.1, 2, 0, 0;     %sigtg 20
 5, -100,100, 1, 0;   %tg0 21
 0, 0.04,4, 1,0 ;     %sigmtg 22
  5, 0, 1, 0, 0;   %rhoTG    23 
 
 0, 0.03,4,       1,0 ;   %24sigmy
 0, 0.04,4,       1,0 ;   %25sigmp
 0, 0.04,4,       1,0 ;   %26sigmr
%  5, -100,100, 0, 0;   %zz0 21
];

    
paraname = { ...
'sig_C   '; 
'nu_l    '; 
'iota_p  '; 
'zeta_p  '; 
'psi1    '; 
'psi2    '; 
'rhor    '; 
'rrst    '; 
'pist    '; 
'gamst   '; 
'rhog    '; 
'rhoz    '; 
'varphi_z'; 
'sigr    '; 
'sigg    '; 
'sigz    '; 
'sigr0    '; 
'sigg0    '; 
'sigz0    '; 
'sigtg   '; ... %sigtg   : shock to target rate
'tg0     '; ... %tg0     : initial target rate
'sigmtg  '; ... %sigtg   : me on target rate
'rhoTG  '; ... %rhoTG: AR(1) coeff
'sigmy   ';
'sigmp   ';
'sigmr   ';
% 'zz0   ';
};

% SV prior 
priorSV.R1 = [0.9; 0.9; 0.9; 0.9];
priorSV.R2 = [0.07; 0.07; 0.07; 0.07];
priorSV.T  = [2; 2; 2; 2];
priorSV.V  = [0.05; 0.05; 0.05; 0.05];
priorSV.C1 = [0,0,0,0];
priorSV.C2 = [10,10,10,10];
priorSV.unitroot = 0;
% priorSV.unitroot = 1;

[spp,nupp] = gamma_trans_snu(priorSV.T,priorSV.V); %from ig(a,b) to ig(s2,nu)
mpp = priorSV.R1;
Vpp = priorSV.R2;

priorSV.prior = [ ...
    3, mpp(1), sqrt(Vpp(1)),     0,0.1; ...%Rh(1)
    3, mpp(2), sqrt(Vpp(2)),     0,0.1; ...%Rh(2)
    3, mpp(3), sqrt(Vpp(3)),     0,0.1; ...%Rh(3)
    0, spp(1), nupp(1),  0,0.1; ...%sqVh(1)
    0, spp(2), nupp(2),  0,0.1; ...%sqVh(2)
    0, spp(3), nupp(3),  0,0.1; ...%sqVh(3)
];

% for estinfo.Vh=1
% sqrt(Vh/(1-Rh)^2) = sigh
% preserving mean
% newS = sqrt(oldS^2/(1-Rh))
priorSV.prior2 = [ ...
    3, mpp(1), sqrt(Vpp(1)),     0,0.1; ...%Rh(1)
    3, mpp(2), sqrt(Vpp(2)),     0,0.1; ...%Rh(2)
    3, mpp(3), sqrt(Vpp(3)),     0,0.1; ...%Rh(3)
    0, sqrt(spp(1)^2/sqrt(1-mpp(1)^2)), nupp(1),  0,0.1; ...%sqVh(1)
    0, sqrt(spp(2)^2/sqrt(1-mpp(2)^2)), nupp(2),  0,0.1; ...%sqVh(2)
    0, sqrt(spp(3)^2/sqrt(1-mpp(3)^2)), nupp(3),  0,0.1; ...%sqVh(3)
];

priorSV.paraname = { ...
    'Rh1   '; ...
    'Rh2   '; ...
    'Rh3   '; ...
    'sqVh1   '; ...
    'sqVh2   '; ...
    'sqVh3   '; ...
    };

priorSV.bounds = [...
    -1, 1; 
    -1, 1;
    -1, 1;
    0, 10;
    0, 10;
    0, 10;
    ];

% MS prior - mp regime
priorMS.prior = [ ...
    3  6, 1, 0, 5; ...    %pistgap
    1, 0.9, 0.05,  0,0.97; ... %pp
    1, 0.9, 0.05,  0,0.92; ... %qq
];

priorMS.paraname = { ...
    'pistgap '; ...
    'p1      '; ...
    'p2      '; ...
    };

priorMS.bounds = [...
    0, 100;
    0, 1; 
    0, 1];


% MS prior - z regime
priorMS2.prior = [ ...
    5  0, 100,       0, 5; ...    %gamgap
    1, 0.9, 0.05,  0,0.97; ... %pp
    1, 0.9, 0.05,  0,0.92; ... %qq
%     5  0, 100,       0, 5; ...    %gamgap
%     5, 0, 1,  0,0.97; ... %pp
%     5, 0, 1,  0,0.92; ... %qq
];

priorMS2.paraname = { ...
    'gamgap '; ...
    'p1      '; ...
    'p2      '; ...
    };

priorMS2.bounds = [...
    0, 100;
    0, 1; 
    0, 1];






